package setup

import (
	"os"
	"testing"

	"github.com/stretchr/testify/assert"
)

// TODO

func TestConfig_Load(t *testing.T) {
	cfg := NewConfig()
	cfg, err := cfg.Load(os.DirFS("../../assets/tests/setup"))
	assert.NoError(t, err)
	assert.Len(t, cfg.Collections, 4)
	assert.Equal(t, cfg.Collections[0].Value(nil).ID, "collection_a")
	assert.Equal(t, cfg.Collections[1].Value(nil).ID, "collection_b")
	assert.Equal(t, cfg.Collections[2].Value(nil).ID, "collection_c")
	{
		coll := cfg.Collections[3].Value(nil)
		assert.Equal(t, "collection_d", coll.ID)
		assert.Equal(t, map[string]map[string]string{
			"en": {"name": "Collection D"},
			"fr": {"name": "Le Collection D"},
		}, coll.Translations)
	}
}
