// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/telemetry_content
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/spaces -i Spaces -t ../../../assets/templates/middleware/telemetry_content -o telemetry_middleware.go -l ""

import (
	"context"
	"time"

	pkgId "git.perx.ru/perxis/perxis-go/id"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/options"
	"git.perx.ru/perxis/perxis-go/pkg/spaces"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

type spaceGetter interface {
	GetSpaceID() string
}

// telemetryMiddleware implements spaces.Spaces interface instrumented with opentracing spans
type telemetryMiddleware struct {
	spaces.Spaces
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base spaces.Spaces, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Spaces:         base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// AbortTransfer implements spaces.Spaces
func (_d telemetryMiddleware) AbortTransfer(ctx context.Context, id string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "AbortTransfer"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.AbortTransfer")
	defer _span.End()

	err = _d.Spaces.AbortTransfer(ctx, id)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx": ctx,
			"id":  id}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Create implements spaces.Spaces
func (_d telemetryMiddleware) Create(ctx context.Context, space *spaces.Space) (created *spaces.Space, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Create"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Create")
	defer _span.End()

	created, err = _d.Spaces.Create(ctx, space)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, space, created, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"space": space}, map[string]interface{}{
			"created": created,
			"err":     err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return created, err
}

// Delete implements spaces.Spaces
func (_d telemetryMiddleware) Delete(ctx context.Context, id string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Delete"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Delete")
	defer _span.End()

	err = _d.Spaces.Delete(ctx, id)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx": ctx,
			"id":  id}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Find implements spaces.Spaces
func (_d telemetryMiddleware) Find(ctx context.Context, filter *spaces.Filter, fo *options.FindOptions) (spaces []*spaces.Space, total int, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Find"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Find")
	defer _span.End()

	spaces, total, err = _d.Spaces.Find(ctx, filter, fo)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, filter, fo, spaces, total, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"filter": filter,
			"fo":     fo}, map[string]interface{}{
			"spaces": spaces,
			"total":  total,
			"err":    err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return spaces, total, err
}

// Get implements spaces.Spaces
func (_d telemetryMiddleware) Get(ctx context.Context, id string) (space *spaces.Space, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Get"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Get")
	defer _span.End()

	space, err = _d.Spaces.Get(ctx, id)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, space, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx": ctx,
			"id":  id}, map[string]interface{}{
			"space": space,
			"err":   err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return space, err
}

// List implements spaces.Spaces
func (_d telemetryMiddleware) List(ctx context.Context, orgId string) (spaces []*spaces.Space, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "List"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.List")
	defer _span.End()

	spaces, err = _d.Spaces.List(ctx, orgId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, orgId, spaces, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"orgId": orgId}, map[string]interface{}{
			"spaces": spaces,
			"err":    err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return spaces, err
}

// ListTransfers implements spaces.Spaces
func (_d telemetryMiddleware) ListTransfers(ctx context.Context, orgID string) (spaces []*spaces.Space, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "ListTransfers"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.ListTransfers")
	defer _span.End()

	spaces, err = _d.Spaces.ListTransfers(ctx, orgID)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, orgID, spaces, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"orgID": orgID}, map[string]interface{}{
			"spaces": spaces,
			"err":    err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return spaces, err
}

// Move implements spaces.Spaces
func (_d telemetryMiddleware) Move(ctx context.Context, id string, orgID string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Move"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Move")
	defer _span.End()

	err = _d.Spaces.Move(ctx, id, orgID)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, orgID, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"id":    id,
			"orgID": orgID}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// SetState implements spaces.Spaces
func (_d telemetryMiddleware) SetState(ctx context.Context, id string, state *spaces.StateInfo) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "SetState"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.SetState")
	defer _span.End()

	err = _d.Spaces.SetState(ctx, id, state)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, state, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"id":    id,
			"state": state}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Transfer implements spaces.Spaces
func (_d telemetryMiddleware) Transfer(ctx context.Context, id string, transferToOrg string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Transfer"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Transfer")
	defer _span.End()

	err = _d.Spaces.Transfer(ctx, id, transferToOrg)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, transferToOrg, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":           ctx,
			"id":            id,
			"transferToOrg": transferToOrg}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Update implements spaces.Spaces
func (_d telemetryMiddleware) Update(ctx context.Context, space *spaces.Space) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "Update"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.Update")
	defer _span.End()

	err = _d.Spaces.Update(ctx, space)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, space, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"space": space}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// UpdateConfig implements spaces.Spaces
func (_d telemetryMiddleware) UpdateConfig(ctx context.Context, id string, config *spaces.Config) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Spaces"),
		attribute.String("method", "UpdateConfig"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Spaces.UpdateConfig")
	defer _span.End()

	err = _d.Spaces.UpdateConfig(ctx, id, config)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, id, config, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"id":     id,
			"config": config}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}
